// Program begin
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;
sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
void main()
{
float tempres;
// For LCD variable
float c,e;
unsigned d,g;
unsigned x1,x2;
char c1,c2,c3;
// For PWM variable
float error;
float t=0; // For storing previous temp
float cherror; //Change of error rate
ADCON1=0x80; // Config A/D converter
TRISA=0xFF; // Set portA as input port
PORTC = 0xFF;
TRISC = 0; // Set PORTC as Output
PORTB = 0xFF;
TRISB=0; // Set PORTB as Output port
PWM1_Init(5000); // initialize PWM at 5 KHZ
while(1)
{
delay_ms(400);
tempres=Adc_Read(2); // Reading of sensor from pin4 (RA2)
tempres=tempres*5; ; //Scaling for sensor(0-1V) and ADC(0-5V) adjustment
error=tempres-286.44; //28C = 286.44, X=(Vin/Vfs)*(2^10-1)
cherror=(error-t)/0.5; // (present temp-past temp/delay)
// see FUZZY table
if((error==0)&& (cherror==0))
Pwm1_Set_Duty(0);
if((error==0)&& (cherror<=-61.38))
Pwm1_Set_Duty(0);
if ((error==0)&& (-61.38<cherror<=-122.76))
Pwm1_Set_Duty(0);
if((error==0)&& (0<cherror<=61.38))
Pwm1_Set_Duty(84.15);

t=error; //for storing past error temp
// LCD Beginning
c=(tempres/1023)*100; ; // For conversion from 286.44 to 28C .
d=c;
e=(c-d)*10;
g=e;
x1=d/10;
x2=d%10;
c1=x1+48;c2=x2+48,c3=g+48;
Lcd_init();
Lcd_Cmd(_LCD_CLEAR);
Lcd_Cmd(_LCD_TURN_OFF);
delay_ms(100);
Lcd_Out(2,1,"SET TEMP=28");
Lcd_Chr_Cp('.');
Lcd_Chr_Cp(223);
Lcd_Out(1,1,"REAL TEMP=");
Lcd_Chr_Cp(c1);
Lcd_Chr_Cp(c2);
Lcd_Chr_Cp('.');
Lcd_Chr_Cp(c3);
Lcd_Chr_Cp(223);
Lcd_Out_Cp("C");
}
}